#BEFORE_TEST.py
from pverify.drivers.Scope.lcscope import IIviScope
from pverify.drivers.SimplifiedLabInstruments import SimpleScope

scope = SimpleScope(IIviScope())  #definition of oscilloscope object
resourcename = 'USB0::0x05FF::0x1023::2801N55814::INSTR' #ID of the oscilloscope used
scope.Initialize(ResourceName=resourcename, IdQuery=True, Reset=False, OptionString='')

# Setting sample_rate and time/DIV
scope.ScopeSetup(0.6, 25e6) #1ms/DIV

#CH2 used as trigger
scope.Trigger_Edge(Level=0.5, Slope='RISE', Position=1, Coupling='DC', ChannelIndex=2)

#SETTING EACH CHANNEL OF THE OSCILLOSCOPE:
scope.ch1 = scope.GetChannel(1)
scope.ch1.ProbeSetup(Coupling='DC', Bandwidth=20e6, Vrange=0.160,
                     Offset=-0.199, Position=0, Probe_Attn=1,
                     Probe_Type='voltage', Impedance=50)

scope.ch2 = scope.GetChannel(2)
scope.ch2.ProbeSetup(Coupling='DC', Bandwidth=200e6, Vrange=8,
                     Offset=-3.8, Position=0, Probe_Attn=1,
                     Probe_Type='voltage', Impedance=50)

scope.ch3 = scope.GetChannel(3)
scope.ch3.ProbeSetup(Coupling='DC', Bandwidth=200e6, Vrange=0.4,
                     Offset=-1.147, Position=0, Probe_Attn=1,
                     Probe_Type='voltage', Impedance=50)

scope.ch4 = scope.GetChannel(4)
scope.ch4.ProbeSetup(Coupling='DC', Bandwidth=200e6, Vrange=0.160,
                     Offset=-0.101, Position=0, Probe_Attn=1,
                      Probe_Type='voltage', Impedance=50)

# Arm scope waiting for the trigger
scope.Arm(Continuous=True)
