from pverify.drivers.Scope.lcscope import IIviScope
from pverify.drivers.SimplifiedLabInstruments import SimpleScope

scope = SimpleScope(IIviScope())
resourcename = 'USB0::0x05FF::0x1023::2801N55814::INSTR'
scope.Initialize(ResourceName=resourcename, IdQuery=True, Reset=False, OptionString='')

# Setting sample_rate and time/DIV
scope.ScopeSetup(0.01, 25e6) #1ms/DIV
#scope.ScopeSetup(0.005, 25e6) #500us/DIV  --> change trigger position --> -70%

#CH2 used as trigger
scope.Trigger_Edge(Level=0.5, Slope='RISE', Position=-30, Coupling='DC', ChannelIndex=2)

#SETTING EACH CHANNEL OF THE OSCILLOSCOPE:
    #CH1: Icore   CH2: Busy_signal   CH3 : Vcore   CH4 : I_Vddp3

scope.ch1 = scope.GetChannel(1)
scope.ch1.ProbeSetup(Coupling='DC', Bandwidth=200e6, Vrange=0.4, Offset=-0.153, Position=0, Probe_Attn=1,
                 Probe_Type='voltage', Impedance=50)

scope.ch2 = scope.GetChannel(2)
scope.ch2.ProbeSetup(Coupling='DC', Bandwidth=200e6, Vrange=8, Offset=-3.8, Position=0, Probe_Attn=1,
                 Probe_Type='voltage', Impedance=50)

scope.ch3 = scope.GetChannel(3)
scope.ch3.ProbeSetup(Coupling='DC', Bandwidth=200e6, Vrange=0.4, Offset=-1.13, Position=0, Probe_Attn=1,
                 Probe_Type='voltage', Impedance=50)


scope.ch4 = scope.GetChannel(4)
scope.ch4.ProbeSetup(Coupling='DC', Bandwidth=200e6, Vrange=0.040, Offset=-0.056, Position=0, Probe_Attn=1,
                 Probe_Type='voltage', Impedance=50)


# Arm scope waiting for the trigger
scope.Arm(Continuous=True)


