from pverify.drivers.Scope.lcscope import IIviScope
from pverify.drivers.SimplifiedLabInstruments import SimpleScope

scope = SimpleScope(IIviScope())
#resourcename = 'USB0::0x05FF::0x1023::2801N55814::INSTR'
resourcename = 'USB0::0x05FF::0x1023::2810N60959::INSTR'
scope.Initialize(ResourceName=resourcename, IdQuery=True, Reset=False, OptionString='')


#EACH CHANNEL OF THE OSCILLOSCOPE:
    #CH1: Icore   CH2: Busy_signal   CH3 : Vcore   CH4 : I_Vddp3
scope.ch1 = scope.GetChannel(1)
scope.ch4 = scope.GetChannel(4)
scope.ch2 = scope.GetChannel(2)
scope.ch3 = scope.GetChannel(3)



dataOfCH1 = scope.ch1.GetProbeWaveform()
dataOfCH1.save_to_file(r'C:\Users\lavignia\Desktop\results\verify\ch1.npz')

dataOfCH2 = scope.ch2.GetProbeWaveform()
dataOfCH2.save_to_file(r'C:\Users\lavignia\Desktop\results\verify\ch2.npz')

dataOfCH3 = scope.ch3.GetProbeWaveform()
dataOfCH3.save_to_file(r'C:\Users\lavignia\Desktop\results\verify\ch3.npz')

#######################################################TO CONTROL THE POWER SUPPLIES########################################################################
from pverify.drivers.DCPwr.hpe364xa import IIviDCPwr
from pverify.drivers.SimplifiedLabInstruments import SimpleDCSource
# initialization
PWR_CORE = SimpleDCSource(IIviDCPwr())
resourcename_core = 'GPIB0::5::INSTR'
PWR_CORE.Initialize(ResourceName=resourcename_core, IdQuery=True, Reset=False, OptionString='simulate=False')
PWR_CORE.chcore = PWR_CORE.GetChannel(1)

PWR_ExtVddp = SimpleDCSource(IIviDCPwr())
resourcename_ext_ddp3 = 'GPIB0::4::INSTR'
PWR_ExtVddp.Initialize(ResourceName=resourcename_ext_ddp3, IdQuery=True, Reset=False, OptionString='simulate=False')
PWR_ExtVddp.ch1 = PWR_ExtVddp.GetChannel(1)
PWR_ExtVddp.ch2 = PWR_ExtVddp.GetChannel(2)


actualVcore = round(PWR_ExtVddp.ch2.Measure_Voltage() , 1) #only one decimal value after the comma
if actualVcore == 5.0:
   # save waveform at this voltage
   dataOfCH1 = scope.ch1.GetProbeWaveform()
   dataOfCH1.save_to_file(r'C:\Users\lavignia\Desktop\results\verify_result\ICORE_nominal.npz')
   dataOfCH4 = scope.ch4.GetProbeWaveform()
   dataOfCH4.save_to_file(r'C:\Users\lavignia\Desktop\results\verify_result\IVddp3_nominal.npz')
   #now, change voltage for next iteration
   PWR_CORE.chcore.Configure_VoltageLevel(Level=1.33, CurrentLimit=1)
   PWR_ExtVddp.ch1.Configure_VoltageLevel(Level=3.63, CurrentLimit=1)
   PWR_ExtVddp.ch2.Configure_VoltageLevel(Level=5.5, CurrentLimit=1)
   PWR_CORE.chcore.Enable(Enabled=True)
   PWR_ExtVddp.ch1.Enable(Enabled=True)
   PWR_ExtVddp.ch2.Enable(Enabled=True)
elif actualVcore == 5.5:
   # save waveform at this voltage
   dataOfCH1 = scope.ch1.GetProbeWaveform()
   dataOfCH1.save_to_file(r'C:\Users\lavignia\Desktop\results\verify_result\ICORE_maximum.npz')
   dataOfCH4 = scope.ch4.GetProbeWaveform()
   dataOfCH4.save_to_file(r'C:\Users\lavignia\Desktop\results\verify_result\IVddp3_maximum.npz')
   #now, change voltage for next iteration
   PWR_CORE.chcore.Configure_VoltageLevel(Level=1.14, CurrentLimit=1)
   PWR_ExtVddp.ch1.Configure_VoltageLevel(Level=3, CurrentLimit=1)
   PWR_ExtVddp.ch2.Configure_VoltageLevel(Level=4, CurrentLimit=1)
   PWR_CORE.chcore.Enable(Enabled=True)
   PWR_ExtVddp.ch1.Enable(Enabled=True)
   PWR_ExtVddp.ch2.Enable(Enabled=True)
elif actualVcore == 4.0:
   # save waveform at this voltage
   dataOfCH1 = scope.ch1.GetProbeWaveform()
   dataOfCH1.save_to_file(r'C:\Users\lavignia\Desktop\results\verify_result\ICORE_minimum.npz')
   dataOfCH4 = scope.ch4.GetProbeWaveform()
   dataOfCH4.save_to_file(r'C:\Users\lavignia\Desktop\results\verify_result\IVddp3_minimum.npz')##

# Arm scope waiting for the trigger
scope.Arm(Continuous=True)

